//+------------------------------------------------------------------+
//|                                            icfxtrader-4major.mq4 |
//|                                                       Cubei.info |
//|                                            http://www.cubei.info |
//+------------------------------------------------------------------+
#property copyright "cubei.info"
#property link      "http://www.cubei.info"
#define icfx 371829

//---- input parameters
extern int  OpenPosHour=0;
extern int  OpenPosMinute=0;
extern int  ClosePosHour=23;
extern int  ClosePosMinute=59;
extern int       TP=60;
extern int       SL=40;
extern int       TradeDir=1;  //1 =Buy, 0=Sell, 2=Both direction
extern double    LotSize=0.1;
extern int       MM=5; //in percent
extern bool      CarryWeekend=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| cllosing all running based on the system                         |
//+------------------------------------------------------------------+
void CloseAll()
{
   if(!CarryWeekend)
   {
      if(DayOfWeek()==5)
         if(TimeHour(TimeCurrent())==20)//asuming that every server time will be at end when the time reaches 20:00
         {
                  for(int i=0;i<OrdersTotal();i++)
                  {
                     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                     bool done=false;
                     if(OrderMagicNumber()==icfx)
                     {
                        double SBid=MarketInfo(OrderSymbol(), MODE_BID);
                        double SAsk=MarketInfo(OrderSymbol(), MODE_ASK);
                        if(OrderType()==OP_BUY)
                        {
                           while(!done)
                              done=OrderClose(OrderTicket(), OrderLots(), SBid, 3, Blue);
                        }
                        else if(OrderType()==OP_SELL)
                        {
                           while(!done)
                              done=OrderClose(OrderTicket(), OrderLots(), SAsk, 3, Red);
                        }
                     }   
                  }

         }
   }
   
   //check weather it's should close the position?
   if(TimeHour(TimeCurrent())==ClosePosHour)
      if(TimeMinute(TimeCurrent())>=ClosePosMinute-1)
      for(i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         done=false;
         if(OrderMagicNumber()==icfx)
         {
            SBid=MarketInfo(OrderSymbol(), MODE_BID);
            SAsk=MarketInfo(OrderSymbol(), MODE_ASK);
            if(OrderType()==OP_BUY)
            {
               while(!done)
                  done=OrderClose(OrderTicket(), OrderLots(), SBid, 3, Blue);
            }
            else if(OrderType()==OP_SELL)
            {
               while(!done)
                  done=OrderClose(OrderTicket(), OrderLots(), SAsk, 3, Red);
            }
         }   
      }
   return;
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
int SymbolOrders=0;
//check on the total orders run for the current symbol
for(int i=0;i<OrdersTotal();i++)
{
   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber()==icfx)
      SymbolOrders++;  
}

//check for input validity
if(OpenPosMinute<0 || OpenPosMinute>=60 ||
   OpenPosHour<0 || OpenPosHour>23 ||
   ClosePosMinute<0 || ClosePosMinute>=60 ||
   ClosePosHour<0 || ClosePosHour>23)
   {
      Comment("the Expert Advisor's inputs is invalid");
   }

//Close all orders when it's time to Close
CloseAll();

//if order for the current symbol allready run, exit functions
if(SymbolOrders>0)
   return(0);

int ticket=-1;
double Lot=LotSize;
if(MM>0)
{
   //pip value for 1 standard lot
   double PipValue=MarketInfo(Symbol(), MODE_TICKVALUE);
   
   double AvailFund=MM/100.0*AccountEquity();
   double ExpectValPerPip=AvailFund/SL;
   
   double LotMM=ExpectValPerPip/PipValue;
   
   if(MarketInfo(Symbol(), MODE_MINLOT)==0.01) LotMM=NormalizeDouble(LotMM, 2);
   else LotMM=NormalizeDouble(LotMM, 1);
   
   Lot=LotMM;
}

if(Lot<MarketInfo(Symbol(), MODE_MINLOT))
{
   Comment("Money Mangement dissallow trades, ACCOUNT IS NOT SUFICE to face the RISKS");
   return(0);
}

if(TimeHour(TimeCurrent())==OpenPosHour)
   if(TimeMinute(TimeCurrent())>OpenPosMinute-1)
   {
      if(TradeDir==1 || TradeDir==2)//if buying
      {
         while(ticket<0)
         {
            ticket=OrderSend(Symbol(), OP_BUY, Lot, Ask, 3, Ask-SL*Point, Ask+TP*Point, "ICFX 4 Major", icfx, 0, Blue);
         }
      }
      else if(TradeDir==0 || TradeDir==2)//if selling
      {
         while(ticket<0)
         {
            ticket=OrderSend(Symbol(), OP_SELL, Lot, Bid, 3, Bid+SL*Point, Bid-TP*Point, "ICFX 4 Major", icfx, 0, Red);
         }
      }
   }
            
            
   
//----
   return(0);
  }
//+------------------------------------------------------------------+